Last Comment Bug 766812 - Exception in HUDService-content.js when the Web Console is closed during network requests
: Exception in HUDService-content.js when the Web Console is closed during netw...
Status: RESOLVED FIXED
[fixed-in-fx-team]
: regression
Product: Firefox
Classification: Client Software
Component: Developer Tools: Console (show other bugs)
: Trunk
: All All
: -- normal (vote)
: Firefox 16
Assigned To: Mihai Sucan [:msucan]
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-20 18:12 PDT by Loic
Modified: 2012-07-03 03:30 PDT (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed


Attachments
[in-fx-team] proposed patch (1.10 KB, patch)
2012-06-25 04:27 PDT, Mihai Sucan [:msucan]
rcampbell: review+
akeybl: approval‑mozilla‑aurora+
Details | Diff | Splinter Review

Description Loic 2012-06-20 18:12:31 PDT
STR:

1) Open WebGL demo http://www.jeshua.me/spectrascade/sc (wait for full loading)
2) Open the Web Console (Ctrl+Shift+K)
3) Open the Error Console (Ctrll+Shift+J)
4) Close the Web Console (with the close X button)
5) Close the browser window (not the Error console window)

Error message displayed in Error Console:

Error: NetUtil is null
Source File: chrome://browser/content/devtools/HUDService-content.js
Line: 1479
Comment 1 Loic 2012-06-20 18:15:35 PDT
Addition: it looks like step #5 is not necessary.
Comment 2 Mihai Sucan [:msucan] 2012-06-21 02:10:46 PDT
Thanks for your bug report. I will look into this.
Comment 3 Mihai Sucan [:msucan] 2012-06-25 04:12:59 PDT
I was able to reproduce by closing the Web Console before the page fully loaded.
Comment 4 Mihai Sucan [:msucan] 2012-06-25 04:27:04 PDT
Created attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

Problem: NRL_onDataAvailable() continues to be called after HUDService-content.js destroys itself (once the user closes the Web Console). NetUtil and NetworkHelper are both used within NRL for keeping the network request ongoing, until it "naturally" stops. This patch no longer removes NetUtil and NetworkHelper to ensure safe functioning of NRL. This should cause no memleaks.

We probably want this in Aurora as well?
Comment 5 Rob Campbell [:rc] (:robcee) 2012-06-25 09:04:24 PDT
Comment on attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

"should cause no memory leaks". Let's verify with a Try run. R+ on completion of that.
Comment 6 Mihai Sucan [:msucan] 2012-06-25 12:48:52 PDT
Thank you!

Green results:
https://tbpl.mozilla.org/?tree=Try&rev=39f61221d634
Comment 7 Mihai Sucan [:msucan] 2012-06-26 03:43:20 PDT
Comment on attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

https://hg.mozilla.org/integration/fx-team/rev/05bd5e010835
Comment 8 Tim Taubert [:ttaubert] 2012-06-26 11:05:52 PDT
https://hg.mozilla.org/mozilla-central/rev/05bd5e010835
Comment 9 Mihai Sucan [:msucan] 2012-07-02 02:29:26 PDT
Comment on attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

[Approval Request Comment]
Bug caused by (feature/regressing bug #): bug 673148 - in the fight with memory leaks we ended up with nulling out some objects imported from JSM's. Network-related helper functions should not be nulled out to prevent any breakage in network request handling.
User impact if declined: If the Web Console is closed during network requests there might show an error in the error console. Otherwise, things should be fine.
Testing completed (on m-c, etc.): several green try runs, green runs in fx-team and m-c team. No problems until now.
Risk to taking this patch (and alternatives if risky): None.
String or UUID changes made by this patch: None.
Comment 10 Alex Keybl [:akeybl] 2012-07-02 16:35:54 PDT
Comment on attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

[Triage Comment]
Approving for Aurora 15 given this is a new regression with a near-zero risk fix.
Comment 11 Mihai Sucan [:msucan] 2012-07-03 03:28:05 PDT
Comment on attachment 636277 [details] [diff] [review]
[in-fx-team] proposed patch

Landed:
https://hg.mozilla.org/releases/mozilla-aurora/rev/01fa3762b23f

Thank you Alex!

Note You need to log in before you can comment on or make changes to this bug.